﻿using System;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;

using System.Media; // Для звука 

namespace MyCompany.UserControls
{
    public partial class BeepButton : Button
    {
        public BeepButton()
        {
            InitializeComponent();
        }

        public BeepButton(IContainer container)
        {
            container.Add(this);

            InitializeComponent();
        }
    }
}

namespace MyCompany.UserControls
{
    partial class BeepButton
    {
        // Переопределяем виртуальный метод диспетчеризации
        // класса Control (задействуется наследуемый метод
        // диспетчеризации класса кнопки)
        protected override void OnClick(EventArgs e)
        {
            // Проиграть системный звук 
            //SystemSounds.Exclamation.Play();// Сочный через внешние динамики
            //SystemSounds.Beep.Play();     // Простой через внешние динамики
            System.Console.Beep();        // Простой через внутренний динамик

            // Подняться до базового класса Control,
            // чтобы сгенерировать его событие Click и 
            // запустить наш будущий обработчик ButtonOnClick
            base.OnClick(e);
        }
    }
}


