﻿using System;
using System.ComponentModel;
using System.Collections.Generic;
using System.Diagnostics;
    
using System.Drawing;
using System.Windows.Forms;
    
namespace MyCompany.UserControls
{
    public partial class CircleButton : Button
    {
        public CircleButton()
        {
            InitializeComponent();
    
            Init();
        }
    
        public CircleButton(IContainer container)
        {
            container.Add(this);
    
            InitializeComponent();
    
            Init();
        }
    
        // Начальные настройки для выполнения в конструкторе
        private void Init()
        {
            // Извещаем операционную систему, что будем сами
            // заботиться об отрисовке компонента
            this.SetStyle(ControlStyles.UserPaint, true);
    
            // Игнорировать системное сообщение WM_ERASEBKGND 
            // очистки окна, чтобы уменьшить нежелательное мерцание 
            this.SetStyle(ControlStyles.AllPaintingInWmPaint, true);
    
            // Наружный отступ по контуру кнопки
            this.Margin = new Padding(this.Font.Height);
    
            // Подстраиваться под размер надписи
            this.AutoSize = true;
        }

        // Вычисляем размер описывающего квадрата кнопки
        // в зависимости от размера надписи на ней
        public override Size GetPreferredSize(Size proposedSize)
        {
            // Получаем ссылку на контекст графического устройства
            Graphics gr = CreateGraphics();
                
            // Измеряем размер описывающего текст прямоугольника
            SizeF box = gr.MeasureString(this.Text, this.Font);
                
            // Вычисляем диагональ текстового блока надписи
            int diagonal = (int)Math.Sqrt(Math.Pow(box.Width, 2) 
                + Math.Pow(box.Height, 2));
                
            // Возвращаем объект с размерами описывающего квадрата кнопки
            return new Size(diagonal, diagonal);
        }
    }
}